<html>
<head>
<title>OGRE: Ogre::DefaultHardwareBufferManager Class Reference - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.5.3 -->
<div class="tabs">
  <ul>
    <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
    <li><a href="namespaces.html"><span>Namespaces</span></a></li>
    <li class="current"><a href="classes.html"><span>Classes</span></a></li>
    <li><a href="files.html"><span>Files</span></a></li>
    <li><a href="dirs.html"><span>Directories</span></a></li>
    <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
  </ul>
</div>
<div class="tabs">
  <ul>
    <li><a href="classes.html"><span>Alphabetical&nbsp;List</span></a></li>
    <li><a href="annotated.html"><span>Class&nbsp;List</span></a></li>
    <li><a href="hierarchy.html"><span>Class&nbsp;Hierarchy</span></a></li>
    <li><a href="functions.html"><span>Class&nbsp;Members</span></a></li>
  </ul>
</div>
<div class="nav">
<a class="el" href="namespaceOgre.html">Ogre</a>::<a class="el" href="classOgre_1_1DefaultHardwareBufferManager.html">DefaultHardwareBufferManager</a></div>
<h1>Ogre::DefaultHardwareBufferManager Class Reference</h1><!-- doxytag: class="Ogre::DefaultHardwareBufferManager" --><!-- doxytag: inherits="Ogre::HardwareBufferManager" -->Specialisation of <a class="el" href="classOgre_1_1HardwareBufferManager.html" title="Abstract singleton class for managing hardware buffers, a concrete instance of this...">HardwareBufferManager</a> to emulate hardware buffers.  
<a href="#_details">More...</a>
<p>
<code>#include &lt;<a class="el" href="OgreDefaultHardwareBufferManager_8h-source.html">OgreDefaultHardwareBufferManager.h</a>&gt;</code>
<p>
<div class="dynheader">
Inheritance diagram for Ogre::DefaultHardwareBufferManager:</div>
<div class="dynsection">
<center><font size="2">[<a href="graph_legend.html">legend</a>]</font></center></div>

<p>
<a href="classOgre_1_1DefaultHardwareBufferManager-members.html">List of all members.</a><table border="0" cellpadding="0" cellspacing="0">
<tr><td></td></tr>
<tr><td colspan="2"><br><h2>Public Types</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">enum &nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1HardwareBufferManager.html#44c2e8b8f5664fa3aad2de27723d0be4">BufferLicenseType</a> { <a class="el" href="classOgre_1_1HardwareBufferManager.html#44c2e8b8f5664fa3aad2de27723d0be4226950ab5142d2fc2e0a4b9d4da45312">BLT_MANUAL_RELEASE</a>, 
<a class="el" href="classOgre_1_1HardwareBufferManager.html#44c2e8b8f5664fa3aad2de27723d0be42b5264f5aa05c0c07ec752e233025a8c">BLT_AUTOMATIC_RELEASE</a>
 }</td></tr>

<tr><td colspan="2"><br><h2>Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1DefaultHardwareBufferManager.html#4cd035da8caa2867d327ea9490f91c4d">DefaultHardwareBufferManager</a> ()</td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1DefaultHardwareBufferManager.html#222290dca734e3cb879691b334776e34">~DefaultHardwareBufferManager</a> ()</td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1HardwareVertexBufferSharedPtr.html">HardwareVertexBufferSharedPtr</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1DefaultHardwareBufferManager.html#fc4b33f07c23045e13db48baae0e6dc4">createVertexBuffer</a> (size_t vertexSize, size_t numVerts, <a class="el" href="classOgre_1_1HardwareBuffer.html#e51f5970d879af736e4cf53e1ec46630">HardwareBuffer::Usage</a> usage, bool useShadowBuffer=false)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Creates a vertex buffer.  <a href="#fc4b33f07c23045e13db48baae0e6dc4"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1HardwareIndexBufferSharedPtr.html">HardwareIndexBufferSharedPtr</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1DefaultHardwareBufferManager.html#1058293f89bf34bcfacff9b122944ccf">createIndexBuffer</a> (<a class="el" href="classOgre_1_1HardwareIndexBuffer.html#25ba4923e015d46de162f7cc4c256326">HardwareIndexBuffer::IndexType</a> itype, size_t numIndexes, <a class="el" href="classOgre_1_1HardwareBuffer.html#e51f5970d879af736e4cf53e1ec46630">HardwareBuffer::Usage</a> usage, bool useShadowBuffer=false)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Create a hardware vertex buffer.  <a href="#1058293f89bf34bcfacff9b122944ccf"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual <br>
<a class="el" href="classOgre_1_1VertexDeclaration.html">VertexDeclaration</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1HardwareBufferManager.html#0d6a29a55a89d937cec4cbaa6c7e8b4b">createVertexDeclaration</a> (void)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Creates a new vertex declaration.  <a href="#0d6a29a55a89d937cec4cbaa6c7e8b4b"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1HardwareBufferManager.html#8df941430aef9a6c87660655b51672a3">destroyVertexDeclaration</a> (<a class="el" href="classOgre_1_1VertexDeclaration.html">VertexDeclaration</a> *decl)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Destroys a vertex declaration.  <a href="#8df941430aef9a6c87660655b51672a3"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual <br>
<a class="el" href="classOgre_1_1VertexBufferBinding.html">VertexBufferBinding</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1HardwareBufferManager.html#4d907dd6ed467886ca7df6a188b73d4d">createVertexBufferBinding</a> (void)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Creates a new <a class="el" href="classOgre_1_1VertexBufferBinding.html" title="Records the state of all the vertex buffer bindings required to provide a vertex...">VertexBufferBinding</a>.  <a href="#4d907dd6ed467886ca7df6a188b73d4d"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1HardwareBufferManager.html#f5abdc6a7e28634b759189e54f1e6fdd">destroyVertexBufferBinding</a> (<a class="el" href="classOgre_1_1VertexBufferBinding.html">VertexBufferBinding</a> *binding)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Destroys a <a class="el" href="classOgre_1_1VertexBufferBinding.html" title="Records the state of all the vertex buffer bindings required to provide a vertex...">VertexBufferBinding</a>.  <a href="#f5abdc6a7e28634b759189e54f1e6fdd"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1HardwareBufferManager.html#763b65efa057185d7acbe073bf0e3610">registerVertexBufferSourceAndCopy</a> (const <a class="el" href="classOgre_1_1HardwareVertexBufferSharedPtr.html">HardwareVertexBufferSharedPtr</a> &amp;sourceBuffer, const <a class="el" href="classOgre_1_1HardwareVertexBufferSharedPtr.html">HardwareVertexBufferSharedPtr</a> &amp;copy)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Registers a vertex buffer as a copy of another.  <a href="#763b65efa057185d7acbe073bf0e3610"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual <br>
<a class="el" href="classOgre_1_1HardwareVertexBufferSharedPtr.html">HardwareVertexBufferSharedPtr</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1HardwareBufferManager.html#9061909fca1c96d50ddbeeee6df8a4d8">allocateVertexBufferCopy</a> (const <a class="el" href="classOgre_1_1HardwareVertexBufferSharedPtr.html">HardwareVertexBufferSharedPtr</a> &amp;sourceBuffer, <a class="el" href="classOgre_1_1HardwareBufferManager.html#44c2e8b8f5664fa3aad2de27723d0be4">BufferLicenseType</a> licenseType, <a class="el" href="classOgre_1_1HardwareBufferLicensee.html">HardwareBufferLicensee</a> *licensee, bool copyData=false)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Allocates a copy of a given vertex buffer.  <a href="#9061909fca1c96d50ddbeeee6df8a4d8"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1HardwareBufferManager.html#34bc652b029f856a5b130f850ba333a0">releaseVertexBufferCopy</a> (const <a class="el" href="classOgre_1_1HardwareVertexBufferSharedPtr.html">HardwareVertexBufferSharedPtr</a> &amp;bufferCopy)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Manually release a vertex buffer copy for others to subsequently use.  <a href="#34bc652b029f856a5b130f850ba333a0"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1HardwareBufferManager.html#f83a478657dabe2d2e35f0d876abcc5b">touchVertexBufferCopy</a> (const <a class="el" href="classOgre_1_1HardwareVertexBufferSharedPtr.html">HardwareVertexBufferSharedPtr</a> &amp;bufferCopy)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Tell engine that the vertex buffer copy intent to reuse.  <a href="#f83a478657dabe2d2e35f0d876abcc5b"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1HardwareBufferManager.html#9a2793066da237001972061b76930c95">_freeUnusedBufferCopies</a> (void)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Free all unused vertex buffer copies.  <a href="#9a2793066da237001972061b76930c95"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1HardwareBufferManager.html#8632cd79b8f18ed2b21bd6b474a49276">_releaseBufferCopies</a> (bool forceFreeUnused=false)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Internal method for releasing all temporary buffers which have been allocated using BLT_AUTOMATIC_RELEASE; is called by OGRE.  <a href="#8632cd79b8f18ed2b21bd6b474a49276"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1HardwareBufferManager.html#b523a5b31c88599812538441b7e37775">_forceReleaseBufferCopies</a> (const <a class="el" href="classOgre_1_1HardwareVertexBufferSharedPtr.html">HardwareVertexBufferSharedPtr</a> &amp;sourceBuffer)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Internal method that forces the release of copies of a given buffer.  <a href="#b523a5b31c88599812538441b7e37775"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1HardwareBufferManager.html#0da9a2c9a66030d32c90871191da0b6a">_forceReleaseBufferCopies</a> (<a class="el" href="classOgre_1_1HardwareVertexBuffer.html">HardwareVertexBuffer</a> *sourceBuffer)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Internal method that forces the release of copies of a given buffer.  <a href="#0da9a2c9a66030d32c90871191da0b6a"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1HardwareBufferManager.html#2b188dbba89b0210ad7359434aa87bee">_notifyVertexBufferDestroyed</a> (<a class="el" href="classOgre_1_1HardwareVertexBuffer.html">HardwareVertexBuffer</a> *buf)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Notification that a hardware vertex buffer has been destroyed.  <a href="#2b188dbba89b0210ad7359434aa87bee"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1HardwareBufferManager.html#ee835c8225ba41a1358db813ce080b0e">_notifyIndexBufferDestroyed</a> (<a class="el" href="classOgre_1_1HardwareIndexBuffer.html">HardwareIndexBuffer</a> *buf)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Notification that a hardware index buffer has been destroyed.  <a href="#ee835c8225ba41a1358db813ce080b0e"></a><br></td></tr>
<tr><td colspan="2"><br><h2>Static Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">static <br>
<a class="el" href="classOgre_1_1HardwareBufferManager.html">HardwareBufferManager</a> &amp;&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1HardwareBufferManager.html#380063fef4a4563c90d45a03ac196dc7">getSingleton</a> (void)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Override standard <a class="el" href="classOgre_1_1Singleton.html" title="Template class for creating single-instance global classes.">Singleton</a> retrieval.  <a href="#380063fef4a4563c90d45a03ac196dc7"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">static <br>
<a class="el" href="classOgre_1_1HardwareBufferManager.html">HardwareBufferManager</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1HardwareBufferManager.html#b633b90f5015dc3199f96e0514347b3b">getSingletonPtr</a> (void)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Override standard <a class="el" href="classOgre_1_1Singleton.html" title="Template class for creating single-instance global classes.">Singleton</a> retrieval.  <a href="#b633b90f5015dc3199f96e0514347b3b"></a><br></td></tr>
<tr><td colspan="2"><br><h2>Protected Types</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">typedef std::set<br>
&lt; <a class="el" href="classOgre_1_1HardwareVertexBuffer.html">HardwareVertexBuffer</a> * &gt;&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1HardwareBufferManager.html#005a83b3e1d4b0f22702b46db94c628f">VertexBufferList</a></td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">WARNING: The following two members should place before all other members.  <a href="#005a83b3e1d4b0f22702b46db94c628f"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">typedef std::set<br>
&lt; <a class="el" href="classOgre_1_1HardwareIndexBuffer.html">HardwareIndexBuffer</a> * &gt;&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1HardwareBufferManager.html#4733bb5bb35bbd11989d815fba0dc8b8">IndexBufferList</a></td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">typedef std::set<br>
&lt; <a class="el" href="classOgre_1_1VertexDeclaration.html">VertexDeclaration</a> * &gt;&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1HardwareBufferManager.html#d0a869ca526ad6799d90511ae7c97727">VertexDeclarationList</a></td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">typedef std::set<br>
&lt; <a class="el" href="classOgre_1_1VertexBufferBinding.html">VertexBufferBinding</a> * &gt;&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1HardwareBufferManager.html#9f67a783dda9530e91c251ad6fabd2f1">VertexBufferBindingList</a></td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">typedef <br>
std::multimap<br>
&lt; <a class="el" href="classOgre_1_1HardwareVertexBuffer.html">HardwareVertexBuffer</a> *,<br>
 <a class="el" href="classOgre_1_1HardwareVertexBufferSharedPtr.html">HardwareVertexBufferSharedPtr</a> &gt;&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1HardwareBufferManager.html#2d5d58855ea1e2cf6b2c4e1250b1ce61">FreeTemporaryVertexBufferMap</a></td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Map from original buffer to temporary buffers.  <a href="#2d5d58855ea1e2cf6b2c4e1250b1ce61"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">typedef std::map<br>
&lt; <a class="el" href="classOgre_1_1HardwareVertexBuffer.html">HardwareVertexBuffer</a> *,<br>
 VertexBufferLicense &gt;&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1HardwareBufferManager.html#826b96eb064f7e66361b53dba1867b6f">TemporaryVertexBufferLicenseMap</a></td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Map from temporary buffer to details of a license.  <a href="#826b96eb064f7e66361b53dba1867b6f"></a><br></td></tr>
<tr><td colspan="2"><br><h2>Protected Member Functions</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1HardwareBufferManager.html#5e9742143f589f88baa1932ca6e6c5ca">destroyAllDeclarations</a> (void)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Internal method for destroys all vertex declarations.  <a href="#5e9742143f589f88baa1932ca6e6c5ca"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1HardwareBufferManager.html#b90f062df30fc1e3b2c480f4643739ea">destroyAllBindings</a> (void)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Internal method for destroys all vertex buffer bindings.  <a href="#b90f062df30fc1e3b2c480f4643739ea"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual <br>
<a class="el" href="classOgre_1_1VertexDeclaration.html">VertexDeclaration</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1HardwareBufferManager.html#11503684fa072a6ff6a74c3a2e01896d">createVertexDeclarationImpl</a> (void)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Internal method for creates a new vertex declaration, may be overridden by certain rendering APIs.  <a href="#11503684fa072a6ff6a74c3a2e01896d"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1HardwareBufferManager.html#3cac422c11632fcae94d828db58aab73">destroyVertexDeclarationImpl</a> (<a class="el" href="classOgre_1_1VertexDeclaration.html">VertexDeclaration</a> *decl)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Internal method for destroys a vertex declaration, may be overridden by certain rendering APIs.  <a href="#3cac422c11632fcae94d828db58aab73"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual <br>
<a class="el" href="classOgre_1_1VertexBufferBinding.html">VertexBufferBinding</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1HardwareBufferManager.html#02f6d91dfb93173e817503beeb2c2a4d">createVertexBufferBindingImpl</a> (void)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Internal method for creates a new <a class="el" href="classOgre_1_1VertexBufferBinding.html" title="Records the state of all the vertex buffer bindings required to provide a vertex...">VertexBufferBinding</a>, may be overridden by certain rendering APIs.  <a href="#02f6d91dfb93173e817503beeb2c2a4d"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1HardwareBufferManager.html#75e8091121a13e66e94f99ea95b66a0c">destroyVertexBufferBindingImpl</a> (<a class="el" href="classOgre_1_1VertexBufferBinding.html">VertexBufferBinding</a> *binding)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Internal method for destroys a <a class="el" href="classOgre_1_1VertexBufferBinding.html" title="Records the state of all the vertex buffer bindings required to provide a vertex...">VertexBufferBinding</a>, may be overridden by certain rendering APIs.  <a href="#75e8091121a13e66e94f99ea95b66a0c"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1HardwareVertexBufferSharedPtr.html">HardwareVertexBufferSharedPtr</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1HardwareBufferManager.html#d20854717425ed03395fb0433b566e3b">makeBufferCopy</a> (const <a class="el" href="classOgre_1_1HardwareVertexBufferSharedPtr.html">HardwareVertexBufferSharedPtr</a> &amp;source, <a class="el" href="classOgre_1_1HardwareBuffer.html#e51f5970d879af736e4cf53e1ec46630">HardwareBuffer::Usage</a> usage, bool useShadowBuffer)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Creates a new buffer as a copy of the source, does not copy data.  <a href="#d20854717425ed03395fb0433b566e3b"></a><br></td></tr>
<tr><td colspan="2"><br><h2>Protected Attributes</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1HardwareBufferManager.html#005a83b3e1d4b0f22702b46db94c628f">VertexBufferList</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1HardwareBufferManager.html#e15225693e51ed0f909291e51f3a9345">mVertexBuffers</a></td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1HardwareBufferManager.html#4733bb5bb35bbd11989d815fba0dc8b8">IndexBufferList</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1HardwareBufferManager.html#e8123944800717cc088e0a69552ab377">mIndexBuffers</a></td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1HardwareBufferManager.html#d0a869ca526ad6799d90511ae7c97727">VertexDeclarationList</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1HardwareBufferManager.html#51c42a14b251f33136fd66c7850c1b73">mVertexDeclarations</a></td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1HardwareBufferManager.html#9f67a783dda9530e91c251ad6fabd2f1">VertexBufferBindingList</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1HardwareBufferManager.html#5b4b47bedc54d3e5c37e06eb15acdfde">mVertexBufferBindings</a></td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1HardwareBufferManager.html#2d5d58855ea1e2cf6b2c4e1250b1ce61">FreeTemporaryVertexBufferMap</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1HardwareBufferManager.html#6894d555b7760538fd78c43dce12c391">mFreeTempVertexBufferMap</a></td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Map of current available temp buffers.  <a href="#6894d555b7760538fd78c43dce12c391"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1HardwareBufferManager.html#826b96eb064f7e66361b53dba1867b6f">TemporaryVertexBufferLicenseMap</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1HardwareBufferManager.html#0b16c3a739a5167cf8718548bda89c11">mTempVertexBufferLicenses</a></td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Map of currently licensed temporary buffers.  <a href="#0b16c3a739a5167cf8718548bda89c11"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">size_t&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1HardwareBufferManager.html#125df1caf80d70e2e57814900cda6a5b">mUnderUsedFrameCount</a></td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Number of frames elapsed since temporary buffers utilization was above half the available.  <a href="#125df1caf80d70e2e57814900cda6a5b"></a><br></td></tr>
<tr><td colspan="2"><br><h2>Static Protected Attributes</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">static const size_t&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1HardwareBufferManager.html#8dc0c6a44a1fe09f951cb6c868dec21f">UNDER_USED_FRAME_THRESHOLD</a></td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Number of frames to wait before free unused temporary buffers.  <a href="#8dc0c6a44a1fe09f951cb6c868dec21f"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">static const size_t&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1HardwareBufferManager.html#9fb27e86e284b2e672b74de5cfd89479">EXPIRED_DELAY_FRAME_THRESHOLD</a></td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Frame delay for BLT_AUTOMATIC_RELEASE temporary buffers.  <a href="#9fb27e86e284b2e672b74de5cfd89479"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">static T *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Singleton.html#d36ac06b409a2d580217328ef2cd3a01">ms_Singleton</a></td></tr>

</table>
<hr><a name="_details"></a><h2>Detailed Description</h2>
Specialisation of <a class="el" href="classOgre_1_1HardwareBufferManager.html" title="Abstract singleton class for managing hardware buffers, a concrete instance of this...">HardwareBufferManager</a> to emulate hardware buffers. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>You might want to instantiate this class if you want to utilise classes like <a class="el" href="classOgre_1_1MeshSerializer.html" title="Class for serialising mesh data to/from an OGRE .mesh file.">MeshSerializer</a> without having initialised the rendering system (which is required to create a 'real' hardware buffer manager. </dd></dl>

<p>Definition at line <a class="el" href="OgreDefaultHardwareBufferManager_8h-source.html#l00097">97</a> of file <a class="el" href="OgreDefaultHardwareBufferManager_8h-source.html">OgreDefaultHardwareBufferManager.h</a>.</p>
<hr><h2>Member Typedef Documentation</h2>
<a class="anchor" name="005a83b3e1d4b0f22702b46db94c628f"></a><!-- doxytag: member="Ogre::DefaultHardwareBufferManager::VertexBufferList" ref="005a83b3e1d4b0f22702b46db94c628f" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef std::set&lt;<a class="el" href="classOgre_1_1HardwareVertexBuffer.html">HardwareVertexBuffer</a>*&gt; <a class="el" href="classOgre_1_1HardwareBufferManager.html#005a83b3e1d4b0f22702b46db94c628f">Ogre::HardwareBufferManager::VertexBufferList</a><code> [protected, inherited]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
WARNING: The following two members should place before all other members. 
<p>
Members destruct order is very important here, because destructing other members will cause notify back to this class, and then will access to this two members. 
<p>Definition at line <a class="el" href="OgreHardwareBufferManager_8h-source.html#l00105">105</a> of file <a class="el" href="OgreHardwareBufferManager_8h-source.html">OgreHardwareBufferManager.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="4733bb5bb35bbd11989d815fba0dc8b8"></a><!-- doxytag: member="Ogre::DefaultHardwareBufferManager::IndexBufferList" ref="4733bb5bb35bbd11989d815fba0dc8b8" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef std::set&lt;<a class="el" href="classOgre_1_1HardwareIndexBuffer.html">HardwareIndexBuffer</a>*&gt; <a class="el" href="classOgre_1_1HardwareBufferManager.html#4733bb5bb35bbd11989d815fba0dc8b8">Ogre::HardwareBufferManager::IndexBufferList</a><code> [protected, inherited]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreHardwareBufferManager_8h-source.html#l00106">106</a> of file <a class="el" href="OgreHardwareBufferManager_8h-source.html">OgreHardwareBufferManager.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="d0a869ca526ad6799d90511ae7c97727"></a><!-- doxytag: member="Ogre::DefaultHardwareBufferManager::VertexDeclarationList" ref="d0a869ca526ad6799d90511ae7c97727" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef std::set&lt;<a class="el" href="classOgre_1_1VertexDeclaration.html">VertexDeclaration</a>*&gt; <a class="el" href="classOgre_1_1HardwareBufferManager.html#d0a869ca526ad6799d90511ae7c97727">Ogre::HardwareBufferManager::VertexDeclarationList</a><code> [protected, inherited]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreHardwareBufferManager_8h-source.html#l00111">111</a> of file <a class="el" href="OgreHardwareBufferManager_8h-source.html">OgreHardwareBufferManager.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="9f67a783dda9530e91c251ad6fabd2f1"></a><!-- doxytag: member="Ogre::DefaultHardwareBufferManager::VertexBufferBindingList" ref="9f67a783dda9530e91c251ad6fabd2f1" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef std::set&lt;<a class="el" href="classOgre_1_1VertexBufferBinding.html">VertexBufferBinding</a>*&gt; <a class="el" href="classOgre_1_1HardwareBufferManager.html#9f67a783dda9530e91c251ad6fabd2f1">Ogre::HardwareBufferManager::VertexBufferBindingList</a><code> [protected, inherited]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreHardwareBufferManager_8h-source.html#l00112">112</a> of file <a class="el" href="OgreHardwareBufferManager_8h-source.html">OgreHardwareBufferManager.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="2d5d58855ea1e2cf6b2c4e1250b1ce61"></a><!-- doxytag: member="Ogre::DefaultHardwareBufferManager::FreeTemporaryVertexBufferMap" ref="2d5d58855ea1e2cf6b2c4e1250b1ce61" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef std::multimap&lt;<a class="el" href="classOgre_1_1HardwareVertexBuffer.html">HardwareVertexBuffer</a>*, <a class="el" href="classOgre_1_1HardwareVertexBufferSharedPtr.html">HardwareVertexBufferSharedPtr</a>&gt; <a class="el" href="classOgre_1_1HardwareBufferManager.html#2d5d58855ea1e2cf6b2c4e1250b1ce61">Ogre::HardwareBufferManager::FreeTemporaryVertexBufferMap</a><code> [protected, inherited]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Map from original buffer to temporary buffers. 
<p>

<p>Definition at line <a class="el" href="OgreHardwareBufferManager_8h-source.html#l00173">173</a> of file <a class="el" href="OgreHardwareBufferManager_8h-source.html">OgreHardwareBufferManager.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="826b96eb064f7e66361b53dba1867b6f"></a><!-- doxytag: member="Ogre::DefaultHardwareBufferManager::TemporaryVertexBufferLicenseMap" ref="826b96eb064f7e66361b53dba1867b6f" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef std::map&lt;<a class="el" href="classOgre_1_1HardwareVertexBuffer.html">HardwareVertexBuffer</a>*, VertexBufferLicense&gt; <a class="el" href="classOgre_1_1HardwareBufferManager.html#826b96eb064f7e66361b53dba1867b6f">Ogre::HardwareBufferManager::TemporaryVertexBufferLicenseMap</a><code> [protected, inherited]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Map from temporary buffer to details of a license. 
<p>

<p>Definition at line <a class="el" href="OgreHardwareBufferManager_8h-source.html#l00177">177</a> of file <a class="el" href="OgreHardwareBufferManager_8h-source.html">OgreHardwareBufferManager.h</a>.</p>

</div>
</div><p>
<hr><h2>Member Enumeration Documentation</h2>
<a class="anchor" name="44c2e8b8f5664fa3aad2de27723d0be4"></a><!-- doxytag: member="Ogre::DefaultHardwareBufferManager::BufferLicenseType" ref="44c2e8b8f5664fa3aad2de27723d0be4" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">enum <a class="el" href="classOgre_1_1HardwareBufferManager.html#44c2e8b8f5664fa3aad2de27723d0be4">Ogre::HardwareBufferManager::BufferLicenseType</a><code> [inherited]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
<dl compact><dt><b>Enumerator: </b></dt><dd>
<table border="0" cellspacing="2" cellpadding="0">
<tr><td valign="top"><em><a class="anchor" name="44c2e8b8f5664fa3aad2de27723d0be4226950ab5142d2fc2e0a4b9d4da45312"></a><!-- doxytag: member="BLT_MANUAL_RELEASE" ref="44c2e8b8f5664fa3aad2de27723d0be4226950ab5142d2fc2e0a4b9d4da45312" args="" -->BLT_MANUAL_RELEASE</em>&nbsp;</td><td>
Licensee will only release buffer when it says so. </td></tr>
<tr><td valign="top"><em><a class="anchor" name="44c2e8b8f5664fa3aad2de27723d0be42b5264f5aa05c0c07ec752e233025a8c"></a><!-- doxytag: member="BLT_AUTOMATIC_RELEASE" ref="44c2e8b8f5664fa3aad2de27723d0be42b5264f5aa05c0c07ec752e233025a8c" args="" -->BLT_AUTOMATIC_RELEASE</em>&nbsp;</td><td>
Licensee can have license revoked. </td></tr>
</table>
</dl>

<p>Definition at line <a class="el" href="OgreHardwareBufferManager_8h-source.html#l00139">139</a> of file <a class="el" href="OgreHardwareBufferManager_8h-source.html">OgreHardwareBufferManager.h</a>.</p>

</div>
</div><p>
<hr><h2>Constructor &amp; Destructor Documentation</h2>
<a class="anchor" name="4cd035da8caa2867d327ea9490f91c4d"></a><!-- doxytag: member="Ogre::DefaultHardwareBufferManager::DefaultHardwareBufferManager" ref="4cd035da8caa2867d327ea9490f91c4d" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">Ogre::DefaultHardwareBufferManager::DefaultHardwareBufferManager           </td>
          <td>(</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

</div>
</div><p>
<a class="anchor" name="222290dca734e3cb879691b334776e34"></a><!-- doxytag: member="Ogre::DefaultHardwareBufferManager::~DefaultHardwareBufferManager" ref="222290dca734e3cb879691b334776e34" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">Ogre::DefaultHardwareBufferManager::~DefaultHardwareBufferManager           </td>
          <td>(</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

</div>
</div><p>
<hr><h2>Member Function Documentation</h2>
<a class="anchor" name="fc4b33f07c23045e13db48baae0e6dc4"></a><!-- doxytag: member="Ogre::DefaultHardwareBufferManager::createVertexBuffer" ref="fc4b33f07c23045e13db48baae0e6dc4" args="(size_t vertexSize, size_t numVerts, HardwareBuffer::Usage usage, bool useShadowBuffer=false)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1HardwareVertexBufferSharedPtr.html">HardwareVertexBufferSharedPtr</a> Ogre::DefaultHardwareBufferManager::createVertexBuffer           </td>
          <td>(</td>
          <td class="paramtype">size_t&nbsp;</td>
          <td class="paramname"> <em>vertexSize</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&nbsp;</td>
          <td class="paramname"> <em>numVerts</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1HardwareBuffer.html#e51f5970d879af736e4cf53e1ec46630">HardwareBuffer::Usage</a>&nbsp;</td>
          <td class="paramname"> <em>usage</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&nbsp;</td>
          <td class="paramname"> <em>useShadowBuffer</em> = <code>false</code></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Creates a vertex buffer. 
<p>

<p>Implements <a class="el" href="classOgre_1_1HardwareBufferManager.html#812d27a28ace0ffb0a8f0fb7de945679">Ogre::HardwareBufferManager</a>.</p>

</div>
</div><p>
<a class="anchor" name="1058293f89bf34bcfacff9b122944ccf"></a><!-- doxytag: member="Ogre::DefaultHardwareBufferManager::createIndexBuffer" ref="1058293f89bf34bcfacff9b122944ccf" args="(HardwareIndexBuffer::IndexType itype, size_t numIndexes, HardwareBuffer::Usage usage, bool useShadowBuffer=false)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1HardwareIndexBufferSharedPtr.html">HardwareIndexBufferSharedPtr</a> Ogre::DefaultHardwareBufferManager::createIndexBuffer           </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1HardwareIndexBuffer.html#25ba4923e015d46de162f7cc4c256326">HardwareIndexBuffer::IndexType</a>&nbsp;</td>
          <td class="paramname"> <em>itype</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&nbsp;</td>
          <td class="paramname"> <em>numIndexes</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1HardwareBuffer.html#e51f5970d879af736e4cf53e1ec46630">HardwareBuffer::Usage</a>&nbsp;</td>
          <td class="paramname"> <em>usage</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&nbsp;</td>
          <td class="paramname"> <em>useShadowBuffer</em> = <code>false</code></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Create a hardware vertex buffer. 
<p>

<p>Implements <a class="el" href="classOgre_1_1HardwareBufferManager.html#18a45108c297f895c4784f0ed9e1ae8b">Ogre::HardwareBufferManager</a>.</p>

</div>
</div><p>
<a class="anchor" name="5e9742143f589f88baa1932ca6e6c5ca"></a><!-- doxytag: member="Ogre::DefaultHardwareBufferManager::destroyAllDeclarations" ref="5e9742143f589f88baa1932ca6e6c5ca" args="(void)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void Ogre::HardwareBufferManager::destroyAllDeclarations           </td>
          <td>(</td>
          <td class="paramtype">void&nbsp;</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [protected, virtual, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Internal method for destroys all vertex declarations. 
<p>

</div>
</div><p>
<a class="anchor" name="b90f062df30fc1e3b2c480f4643739ea"></a><!-- doxytag: member="Ogre::DefaultHardwareBufferManager::destroyAllBindings" ref="b90f062df30fc1e3b2c480f4643739ea" args="(void)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void Ogre::HardwareBufferManager::destroyAllBindings           </td>
          <td>(</td>
          <td class="paramtype">void&nbsp;</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [protected, virtual, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Internal method for destroys all vertex buffer bindings. 
<p>

</div>
</div><p>
<a class="anchor" name="11503684fa072a6ff6a74c3a2e01896d"></a><!-- doxytag: member="Ogre::DefaultHardwareBufferManager::createVertexDeclarationImpl" ref="11503684fa072a6ff6a74c3a2e01896d" args="(void)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="classOgre_1_1VertexDeclaration.html">VertexDeclaration</a>* Ogre::HardwareBufferManager::createVertexDeclarationImpl           </td>
          <td>(</td>
          <td class="paramtype">void&nbsp;</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [protected, virtual, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Internal method for creates a new vertex declaration, may be overridden by certain rendering APIs. 
<p>

</div>
</div><p>
<a class="anchor" name="3cac422c11632fcae94d828db58aab73"></a><!-- doxytag: member="Ogre::DefaultHardwareBufferManager::destroyVertexDeclarationImpl" ref="3cac422c11632fcae94d828db58aab73" args="(VertexDeclaration *decl)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void Ogre::HardwareBufferManager::destroyVertexDeclarationImpl           </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1VertexDeclaration.html">VertexDeclaration</a> *&nbsp;</td>
          <td class="paramname"> <em>decl</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [protected, virtual, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Internal method for destroys a vertex declaration, may be overridden by certain rendering APIs. 
<p>

</div>
</div><p>
<a class="anchor" name="02f6d91dfb93173e817503beeb2c2a4d"></a><!-- doxytag: member="Ogre::DefaultHardwareBufferManager::createVertexBufferBindingImpl" ref="02f6d91dfb93173e817503beeb2c2a4d" args="(void)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="classOgre_1_1VertexBufferBinding.html">VertexBufferBinding</a>* Ogre::HardwareBufferManager::createVertexBufferBindingImpl           </td>
          <td>(</td>
          <td class="paramtype">void&nbsp;</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [protected, virtual, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Internal method for creates a new <a class="el" href="classOgre_1_1VertexBufferBinding.html" title="Records the state of all the vertex buffer bindings required to provide a vertex...">VertexBufferBinding</a>, may be overridden by certain rendering APIs. 
<p>

</div>
</div><p>
<a class="anchor" name="75e8091121a13e66e94f99ea95b66a0c"></a><!-- doxytag: member="Ogre::DefaultHardwareBufferManager::destroyVertexBufferBindingImpl" ref="75e8091121a13e66e94f99ea95b66a0c" args="(VertexBufferBinding *binding)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void Ogre::HardwareBufferManager::destroyVertexBufferBindingImpl           </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1VertexBufferBinding.html">VertexBufferBinding</a> *&nbsp;</td>
          <td class="paramname"> <em>binding</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [protected, virtual, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Internal method for destroys a <a class="el" href="classOgre_1_1VertexBufferBinding.html" title="Records the state of all the vertex buffer bindings required to provide a vertex...">VertexBufferBinding</a>, may be overridden by certain rendering APIs. 
<p>

</div>
</div><p>
<a class="anchor" name="d20854717425ed03395fb0433b566e3b"></a><!-- doxytag: member="Ogre::DefaultHardwareBufferManager::makeBufferCopy" ref="d20854717425ed03395fb0433b566e3b" args="(const HardwareVertexBufferSharedPtr &amp;source, HardwareBuffer::Usage usage, bool useShadowBuffer)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1HardwareVertexBufferSharedPtr.html">HardwareVertexBufferSharedPtr</a> Ogre::HardwareBufferManager::makeBufferCopy           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1HardwareVertexBufferSharedPtr.html">HardwareVertexBufferSharedPtr</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>source</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1HardwareBuffer.html#e51f5970d879af736e4cf53e1ec46630">HardwareBuffer::Usage</a>&nbsp;</td>
          <td class="paramname"> <em>usage</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&nbsp;</td>
          <td class="paramname"> <em>useShadowBuffer</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"><code> [protected, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Creates a new buffer as a copy of the source, does not copy data. 
<p>

</div>
</div><p>
<a class="anchor" name="0d6a29a55a89d937cec4cbaa6c7e8b4b"></a><!-- doxytag: member="Ogre::DefaultHardwareBufferManager::createVertexDeclaration" ref="0d6a29a55a89d937cec4cbaa6c7e8b4b" args="(void)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="classOgre_1_1VertexDeclaration.html">VertexDeclaration</a>* Ogre::HardwareBufferManager::createVertexDeclaration           </td>
          <td>(</td>
          <td class="paramtype">void&nbsp;</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [virtual, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Creates a new vertex declaration. 
<p>

</div>
</div><p>
<a class="anchor" name="8df941430aef9a6c87660655b51672a3"></a><!-- doxytag: member="Ogre::DefaultHardwareBufferManager::destroyVertexDeclaration" ref="8df941430aef9a6c87660655b51672a3" args="(VertexDeclaration *decl)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void Ogre::HardwareBufferManager::destroyVertexDeclaration           </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1VertexDeclaration.html">VertexDeclaration</a> *&nbsp;</td>
          <td class="paramname"> <em>decl</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [virtual, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Destroys a vertex declaration. 
<p>

</div>
</div><p>
<a class="anchor" name="4d907dd6ed467886ca7df6a188b73d4d"></a><!-- doxytag: member="Ogre::DefaultHardwareBufferManager::createVertexBufferBinding" ref="4d907dd6ed467886ca7df6a188b73d4d" args="(void)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="classOgre_1_1VertexBufferBinding.html">VertexBufferBinding</a>* Ogre::HardwareBufferManager::createVertexBufferBinding           </td>
          <td>(</td>
          <td class="paramtype">void&nbsp;</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [virtual, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Creates a new <a class="el" href="classOgre_1_1VertexBufferBinding.html" title="Records the state of all the vertex buffer bindings required to provide a vertex...">VertexBufferBinding</a>. 
<p>

</div>
</div><p>
<a class="anchor" name="f5abdc6a7e28634b759189e54f1e6fdd"></a><!-- doxytag: member="Ogre::DefaultHardwareBufferManager::destroyVertexBufferBinding" ref="f5abdc6a7e28634b759189e54f1e6fdd" args="(VertexBufferBinding *binding)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void Ogre::HardwareBufferManager::destroyVertexBufferBinding           </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1VertexBufferBinding.html">VertexBufferBinding</a> *&nbsp;</td>
          <td class="paramname"> <em>binding</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [virtual, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Destroys a <a class="el" href="classOgre_1_1VertexBufferBinding.html" title="Records the state of all the vertex buffer bindings required to provide a vertex...">VertexBufferBinding</a>. 
<p>

</div>
</div><p>
<a class="anchor" name="763b65efa057185d7acbe073bf0e3610"></a><!-- doxytag: member="Ogre::DefaultHardwareBufferManager::registerVertexBufferSourceAndCopy" ref="763b65efa057185d7acbe073bf0e3610" args="(const HardwareVertexBufferSharedPtr &amp;sourceBuffer, const HardwareVertexBufferSharedPtr &amp;copy)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void Ogre::HardwareBufferManager::registerVertexBufferSourceAndCopy           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1HardwareVertexBufferSharedPtr.html">HardwareVertexBufferSharedPtr</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>sourceBuffer</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1HardwareVertexBufferSharedPtr.html">HardwareVertexBufferSharedPtr</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>copy</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"><code> [virtual, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Registers a vertex buffer as a copy of another. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>This is useful for registering an existing buffer as a temporary buffer which can be allocated just like a copy. </dd></dl>

</div>
</div><p>
<a class="anchor" name="9061909fca1c96d50ddbeeee6df8a4d8"></a><!-- doxytag: member="Ogre::DefaultHardwareBufferManager::allocateVertexBufferCopy" ref="9061909fca1c96d50ddbeeee6df8a4d8" args="(const HardwareVertexBufferSharedPtr &amp;sourceBuffer, BufferLicenseType licenseType, HardwareBufferLicensee *licensee, bool copyData=false)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="classOgre_1_1HardwareVertexBufferSharedPtr.html">HardwareVertexBufferSharedPtr</a> Ogre::HardwareBufferManager::allocateVertexBufferCopy           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1HardwareVertexBufferSharedPtr.html">HardwareVertexBufferSharedPtr</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>sourceBuffer</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1HardwareBufferManager.html#44c2e8b8f5664fa3aad2de27723d0be4">BufferLicenseType</a>&nbsp;</td>
          <td class="paramname"> <em>licenseType</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1HardwareBufferLicensee.html">HardwareBufferLicensee</a> *&nbsp;</td>
          <td class="paramname"> <em>licensee</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&nbsp;</td>
          <td class="paramname"> <em>copyData</em> = <code>false</code></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"><code> [virtual, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Allocates a copy of a given vertex buffer. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>This method allocates a temporary copy of an existing vertex buffer. This buffer is subsequently stored and can be made available for other purposes later without incurring the cost of construction / destruction. </dd></dl>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>sourceBuffer</em>&nbsp;</td><td>The source buffer to use as a copy </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>licenseType</em>&nbsp;</td><td>The type of license required on this buffer - automatic release causes this class to release licenses every frame so that they can be reallocated anew. </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>licensee</em>&nbsp;</td><td>Pointer back to the class requesting the copy, which must implement HardwareBufferLicense in order to be notified when the license expires. </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>copyData</em>&nbsp;</td><td>If true, the current data is copied as well as the structure of the buffer </td></tr>
  </table>
</dl>

</div>
</div><p>
<a class="anchor" name="34bc652b029f856a5b130f850ba333a0"></a><!-- doxytag: member="Ogre::DefaultHardwareBufferManager::releaseVertexBufferCopy" ref="34bc652b029f856a5b130f850ba333a0" args="(const HardwareVertexBufferSharedPtr &amp;bufferCopy)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void Ogre::HardwareBufferManager::releaseVertexBufferCopy           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1HardwareVertexBufferSharedPtr.html">HardwareVertexBufferSharedPtr</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>bufferCopy</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [virtual, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Manually release a vertex buffer copy for others to subsequently use. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>Only required if the original call to allocateVertexBufferCopy included a licenseType of BLT_MANUAL_RELEASE. </dd></dl>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>bufferCopy</em>&nbsp;</td><td>The buffer copy. The caller is expected to delete or at least no longer use this reference, since another user may well begin to modify the contents of the buffer. </td></tr>
  </table>
</dl>

</div>
</div><p>
<a class="anchor" name="f83a478657dabe2d2e35f0d876abcc5b"></a><!-- doxytag: member="Ogre::DefaultHardwareBufferManager::touchVertexBufferCopy" ref="f83a478657dabe2d2e35f0d876abcc5b" args="(const HardwareVertexBufferSharedPtr &amp;bufferCopy)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void Ogre::HardwareBufferManager::touchVertexBufferCopy           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1HardwareVertexBufferSharedPtr.html">HardwareVertexBufferSharedPtr</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>bufferCopy</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [virtual, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Tell engine that the vertex buffer copy intent to reuse. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd><a class="el" href="namespaceOgre.html">Ogre</a> internal keep an expired delay counter of BLT_AUTOMATIC_RELEASE buffers, when the counter count down to zero, it'll release for other purposes later. But you can use this function to reset the counter to the internal configured value, keep the buffer not get released for some frames. </dd></dl>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>bufferCopy</em>&nbsp;</td><td>The buffer copy. The caller is expected to keep this buffer copy for use. </td></tr>
  </table>
</dl>

</div>
</div><p>
<a class="anchor" name="9a2793066da237001972061b76930c95"></a><!-- doxytag: member="Ogre::DefaultHardwareBufferManager::_freeUnusedBufferCopies" ref="9a2793066da237001972061b76930c95" args="(void)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void Ogre::HardwareBufferManager::_freeUnusedBufferCopies           </td>
          <td>(</td>
          <td class="paramtype">void&nbsp;</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [virtual, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Free all unused vertex buffer copies. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>This method free all temporary vertex buffers that not in used. In normally, temporary vertex buffers are subsequently stored and can be made available for other purposes later without incurring the cost of construction / destruction. But in some cases you want to free them to save hardware memory (e.g. application was runs in a long time, you might free temporary buffers periodically to avoid memory overload). </dd></dl>

</div>
</div><p>
<a class="anchor" name="8632cd79b8f18ed2b21bd6b474a49276"></a><!-- doxytag: member="Ogre::DefaultHardwareBufferManager::_releaseBufferCopies" ref="8632cd79b8f18ed2b21bd6b474a49276" args="(bool forceFreeUnused=false)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void Ogre::HardwareBufferManager::_releaseBufferCopies           </td>
          <td>(</td>
          <td class="paramtype">bool&nbsp;</td>
          <td class="paramname"> <em>forceFreeUnused</em> = <code>false</code>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [virtual, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Internal method for releasing all temporary buffers which have been allocated using BLT_AUTOMATIC_RELEASE; is called by OGRE. 
<p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>forceFreeUnused</em>&nbsp;</td><td>If true, free all unused temporary buffers. If false, auto detect and free all unused temporary buffers based on temporary buffers utilization. </td></tr>
  </table>
</dl>

</div>
</div><p>
<a class="anchor" name="b523a5b31c88599812538441b7e37775"></a><!-- doxytag: member="Ogre::DefaultHardwareBufferManager::_forceReleaseBufferCopies" ref="b523a5b31c88599812538441b7e37775" args="(const HardwareVertexBufferSharedPtr &amp;sourceBuffer)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void Ogre::HardwareBufferManager::_forceReleaseBufferCopies           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1HardwareVertexBufferSharedPtr.html">HardwareVertexBufferSharedPtr</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>sourceBuffer</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [virtual, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Internal method that forces the release of copies of a given buffer. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>This usually means that the buffer which the copies are based on has been changed in some fundamental way, and the owner of the original wishes to make that known so that new copies will reflect the changes. </dd></dl>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>sourceBuffer</em>&nbsp;</td><td>the source buffer as a shared pointer. <a class="el" href="classOgre_1_1Any.html" title="Variant type that can hold Any other type.">Any</a> buffer copies created from the source buffer are deleted. </td></tr>
  </table>
</dl>

</div>
</div><p>
<a class="anchor" name="0da9a2c9a66030d32c90871191da0b6a"></a><!-- doxytag: member="Ogre::DefaultHardwareBufferManager::_forceReleaseBufferCopies" ref="0da9a2c9a66030d32c90871191da0b6a" args="(HardwareVertexBuffer *sourceBuffer)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void Ogre::HardwareBufferManager::_forceReleaseBufferCopies           </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1HardwareVertexBuffer.html">HardwareVertexBuffer</a> *&nbsp;</td>
          <td class="paramname"> <em>sourceBuffer</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [virtual, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Internal method that forces the release of copies of a given buffer. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>This usually means that the buffer which the copies are based on has been changed in some fundamental way, and the owner of the original wishes to make that known so that new copies will reflect the changes. </dd></dl>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>sourceBuffer</em>&nbsp;</td><td>the source buffer as a pointer. <a class="el" href="classOgre_1_1Any.html" title="Variant type that can hold Any other type.">Any</a> buffer copies created from the source buffer are deleted. </td></tr>
  </table>
</dl>

</div>
</div><p>
<a class="anchor" name="2b188dbba89b0210ad7359434aa87bee"></a><!-- doxytag: member="Ogre::DefaultHardwareBufferManager::_notifyVertexBufferDestroyed" ref="2b188dbba89b0210ad7359434aa87bee" args="(HardwareVertexBuffer *buf)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Ogre::HardwareBufferManager::_notifyVertexBufferDestroyed           </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1HardwareVertexBuffer.html">HardwareVertexBuffer</a> *&nbsp;</td>
          <td class="paramname"> <em>buf</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Notification that a hardware vertex buffer has been destroyed. 
<p>

</div>
</div><p>
<a class="anchor" name="ee835c8225ba41a1358db813ce080b0e"></a><!-- doxytag: member="Ogre::DefaultHardwareBufferManager::_notifyIndexBufferDestroyed" ref="ee835c8225ba41a1358db813ce080b0e" args="(HardwareIndexBuffer *buf)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Ogre::HardwareBufferManager::_notifyIndexBufferDestroyed           </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1HardwareIndexBuffer.html">HardwareIndexBuffer</a> *&nbsp;</td>
          <td class="paramname"> <em>buf</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Notification that a hardware index buffer has been destroyed. 
<p>

</div>
</div><p>
<a class="anchor" name="380063fef4a4563c90d45a03ac196dc7"></a><!-- doxytag: member="Ogre::DefaultHardwareBufferManager::getSingleton" ref="380063fef4a4563c90d45a03ac196dc7" args="(void)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static <a class="el" href="classOgre_1_1HardwareBufferManager.html">HardwareBufferManager</a>&amp; Ogre::HardwareBufferManager::getSingleton           </td>
          <td>(</td>
          <td class="paramtype">void&nbsp;</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [static, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Override standard <a class="el" href="classOgre_1_1Singleton.html" title="Template class for creating single-instance global classes.">Singleton</a> retrieval. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>Why do we do this? Well, it's because the <a class="el" href="classOgre_1_1Singleton.html" title="Template class for creating single-instance global classes.">Singleton</a> implementation is in a .h file, which means it gets compiled into anybody who includes it. This is needed for the <a class="el" href="classOgre_1_1Singleton.html" title="Template class for creating single-instance global classes.">Singleton</a> template to work, but we actually only want it compiled into the implementation of the class based on the <a class="el" href="classOgre_1_1Singleton.html" title="Template class for creating single-instance global classes.">Singleton</a>, not all of them. If we don't change this, we get link errors when trying to use the Singleton-based class from an outside dll. </dd></dl>
<dl class="user" compact><dt><b></b></dt><dd>This method just delegates to the template version anyway, but the implementation stays in this single compilation unit, preventing link errors. </dd></dl>

<p>Reimplemented from <a class="el" href="classOgre_1_1Singleton.html#7757bd7ac3702c144502e53ad6491888">Ogre::Singleton&lt; T &gt;</a>.</p>

</div>
</div><p>
<a class="anchor" name="b633b90f5015dc3199f96e0514347b3b"></a><!-- doxytag: member="Ogre::DefaultHardwareBufferManager::getSingletonPtr" ref="b633b90f5015dc3199f96e0514347b3b" args="(void)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static <a class="el" href="classOgre_1_1HardwareBufferManager.html">HardwareBufferManager</a>* Ogre::HardwareBufferManager::getSingletonPtr           </td>
          <td>(</td>
          <td class="paramtype">void&nbsp;</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [static, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Override standard <a class="el" href="classOgre_1_1Singleton.html" title="Template class for creating single-instance global classes.">Singleton</a> retrieval. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>Why do we do this? Well, it's because the <a class="el" href="classOgre_1_1Singleton.html" title="Template class for creating single-instance global classes.">Singleton</a> implementation is in a .h file, which means it gets compiled into anybody who includes it. This is needed for the <a class="el" href="classOgre_1_1Singleton.html" title="Template class for creating single-instance global classes.">Singleton</a> template to work, but we actually only want it compiled into the implementation of the class based on the <a class="el" href="classOgre_1_1Singleton.html" title="Template class for creating single-instance global classes.">Singleton</a>, not all of them. If we don't change this, we get link errors when trying to use the Singleton-based class from an outside dll. </dd></dl>
<dl class="user" compact><dt><b></b></dt><dd>This method just delegates to the template version anyway, but the implementation stays in this single compilation unit, preventing link errors. </dd></dl>

<p>Reimplemented from <a class="el" href="classOgre_1_1Singleton.html#7ab51c46521b89723d6186a52a7e0d7b">Ogre::Singleton&lt; T &gt;</a>.</p>

</div>
</div><p>
<hr><h2>Member Data Documentation</h2>
<a class="anchor" name="e15225693e51ed0f909291e51f3a9345"></a><!-- doxytag: member="Ogre::DefaultHardwareBufferManager::mVertexBuffers" ref="e15225693e51ed0f909291e51f3a9345" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1HardwareBufferManager.html#005a83b3e1d4b0f22702b46db94c628f">VertexBufferList</a> <a class="el" href="classOgre_1_1HardwareBufferManager.html#e15225693e51ed0f909291e51f3a9345">Ogre::HardwareBufferManager::mVertexBuffers</a><code> [protected, inherited]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreHardwareBufferManager_8h-source.html#l00107">107</a> of file <a class="el" href="OgreHardwareBufferManager_8h-source.html">OgreHardwareBufferManager.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="e8123944800717cc088e0a69552ab377"></a><!-- doxytag: member="Ogre::DefaultHardwareBufferManager::mIndexBuffers" ref="e8123944800717cc088e0a69552ab377" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1HardwareBufferManager.html#4733bb5bb35bbd11989d815fba0dc8b8">IndexBufferList</a> <a class="el" href="classOgre_1_1HardwareBufferManager.html#e8123944800717cc088e0a69552ab377">Ogre::HardwareBufferManager::mIndexBuffers</a><code> [protected, inherited]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreHardwareBufferManager_8h-source.html#l00108">108</a> of file <a class="el" href="OgreHardwareBufferManager_8h-source.html">OgreHardwareBufferManager.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="51c42a14b251f33136fd66c7850c1b73"></a><!-- doxytag: member="Ogre::DefaultHardwareBufferManager::mVertexDeclarations" ref="51c42a14b251f33136fd66c7850c1b73" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1HardwareBufferManager.html#d0a869ca526ad6799d90511ae7c97727">VertexDeclarationList</a> <a class="el" href="classOgre_1_1HardwareBufferManager.html#51c42a14b251f33136fd66c7850c1b73">Ogre::HardwareBufferManager::mVertexDeclarations</a><code> [protected, inherited]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreHardwareBufferManager_8h-source.html#l00113">113</a> of file <a class="el" href="OgreHardwareBufferManager_8h-source.html">OgreHardwareBufferManager.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="5b4b47bedc54d3e5c37e06eb15acdfde"></a><!-- doxytag: member="Ogre::DefaultHardwareBufferManager::mVertexBufferBindings" ref="5b4b47bedc54d3e5c37e06eb15acdfde" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1HardwareBufferManager.html#9f67a783dda9530e91c251ad6fabd2f1">VertexBufferBindingList</a> <a class="el" href="classOgre_1_1HardwareBufferManager.html#5b4b47bedc54d3e5c37e06eb15acdfde">Ogre::HardwareBufferManager::mVertexBufferBindings</a><code> [protected, inherited]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreHardwareBufferManager_8h-source.html#l00114">114</a> of file <a class="el" href="OgreHardwareBufferManager_8h-source.html">OgreHardwareBufferManager.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="6894d555b7760538fd78c43dce12c391"></a><!-- doxytag: member="Ogre::DefaultHardwareBufferManager::mFreeTempVertexBufferMap" ref="6894d555b7760538fd78c43dce12c391" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1HardwareBufferManager.html#2d5d58855ea1e2cf6b2c4e1250b1ce61">FreeTemporaryVertexBufferMap</a> <a class="el" href="classOgre_1_1HardwareBufferManager.html#6894d555b7760538fd78c43dce12c391">Ogre::HardwareBufferManager::mFreeTempVertexBufferMap</a><code> [protected, inherited]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Map of current available temp buffers. 
<p>

<p>Definition at line <a class="el" href="OgreHardwareBufferManager_8h-source.html#l00175">175</a> of file <a class="el" href="OgreHardwareBufferManager_8h-source.html">OgreHardwareBufferManager.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="0b16c3a739a5167cf8718548bda89c11"></a><!-- doxytag: member="Ogre::DefaultHardwareBufferManager::mTempVertexBufferLicenses" ref="0b16c3a739a5167cf8718548bda89c11" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1HardwareBufferManager.html#826b96eb064f7e66361b53dba1867b6f">TemporaryVertexBufferLicenseMap</a> <a class="el" href="classOgre_1_1HardwareBufferManager.html#0b16c3a739a5167cf8718548bda89c11">Ogre::HardwareBufferManager::mTempVertexBufferLicenses</a><code> [protected, inherited]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Map of currently licensed temporary buffers. 
<p>

<p>Definition at line <a class="el" href="OgreHardwareBufferManager_8h-source.html#l00179">179</a> of file <a class="el" href="OgreHardwareBufferManager_8h-source.html">OgreHardwareBufferManager.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="125df1caf80d70e2e57814900cda6a5b"></a><!-- doxytag: member="Ogre::DefaultHardwareBufferManager::mUnderUsedFrameCount" ref="125df1caf80d70e2e57814900cda6a5b" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">size_t <a class="el" href="classOgre_1_1HardwareBufferManager.html#125df1caf80d70e2e57814900cda6a5b">Ogre::HardwareBufferManager::mUnderUsedFrameCount</a><code> [protected, inherited]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Number of frames elapsed since temporary buffers utilization was above half the available. 
<p>

<p>Definition at line <a class="el" href="OgreHardwareBufferManager_8h-source.html#l00181">181</a> of file <a class="el" href="OgreHardwareBufferManager_8h-source.html">OgreHardwareBufferManager.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="8dc0c6a44a1fe09f951cb6c868dec21f"></a><!-- doxytag: member="Ogre::DefaultHardwareBufferManager::UNDER_USED_FRAME_THRESHOLD" ref="8dc0c6a44a1fe09f951cb6c868dec21f" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">const size_t <a class="el" href="classOgre_1_1HardwareBufferManager.html#8dc0c6a44a1fe09f951cb6c868dec21f">Ogre::HardwareBufferManager::UNDER_USED_FRAME_THRESHOLD</a><code> [static, protected, inherited]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Number of frames to wait before free unused temporary buffers. 
<p>

<p>Definition at line <a class="el" href="OgreHardwareBufferManager_8h-source.html#l00183">183</a> of file <a class="el" href="OgreHardwareBufferManager_8h-source.html">OgreHardwareBufferManager.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="9fb27e86e284b2e672b74de5cfd89479"></a><!-- doxytag: member="Ogre::DefaultHardwareBufferManager::EXPIRED_DELAY_FRAME_THRESHOLD" ref="9fb27e86e284b2e672b74de5cfd89479" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">const size_t <a class="el" href="classOgre_1_1HardwareBufferManager.html#9fb27e86e284b2e672b74de5cfd89479">Ogre::HardwareBufferManager::EXPIRED_DELAY_FRAME_THRESHOLD</a><code> [static, protected, inherited]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Frame delay for BLT_AUTOMATIC_RELEASE temporary buffers. 
<p>

<p>Definition at line <a class="el" href="OgreHardwareBufferManager_8h-source.html#l00185">185</a> of file <a class="el" href="OgreHardwareBufferManager_8h-source.html">OgreHardwareBufferManager.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="d36ac06b409a2d580217328ef2cd3a01"></a><!-- doxytag: member="Ogre::DefaultHardwareBufferManager::ms_Singleton" ref="d36ac06b409a2d580217328ef2cd3a01" args="" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">T* <a class="el" href="classOgre_1_1Singleton.html">Ogre::Singleton</a>&lt; T &gt;::<a class="el" href="classOgre_1_1Singleton.html#d36ac06b409a2d580217328ef2cd3a01">ms_Singleton</a><code> [static, protected, inherited]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreSingleton_8h-source.html#l00061">61</a> of file <a class="el" href="OgreSingleton_8h-source.html">OgreSingleton.h</a>.</p>

<p>Referenced by <a class="el" href="OgreSingleton_8h-source.html#l00076">Ogre::Singleton&lt; Ogre::FontManager &gt;::getSingleton()</a>, <a class="el" href="OgreSingleton_8h-source.html#l00078">Ogre::Singleton&lt; Ogre::FontManager &gt;::getSingletonPtr()</a>, <a class="el" href="OgreSingleton_8h-source.html#l00064">Ogre::Singleton&lt; Ogre::FontManager &gt;::Singleton()</a>, and <a class="el" href="OgreSingleton_8h-source.html#l00074">Ogre::Singleton&lt; Ogre::FontManager &gt;::~Singleton()</a>.</p>

</div>
</div><p>
<hr>The documentation for this class was generated from the following file:<ul>
<li><a class="el" href="OgreDefaultHardwareBufferManager_8h-source.html">OgreDefaultHardwareBufferManager.h</a></ul>
<hr>
<p>
Copyright &copy; 2000-2005 by The OGRE Team<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/"><img alt="Creative Commons License" border="0" src="http://creativecommons.org/images/public/somerights20.png"/></a><br/>
This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/">Creative Commons Attribution-ShareAlike 2.5 License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Mon Jun 16 12:49:32 2008
</p>
</body>
</html>
